//Subplugin for Bloodrider (The Grenade Spammer)
//Abilities:
//Rage: Gets 1 of 5 random Grenade launchers and get buffed with Minicrit, Defense buff and Regen buff (also, he changes class and gets a Melee weapon, Melee weapons depents on which class he currently is)
//Life Lose, same as above, except of getting 3 buffs, he gets Critboosted and gets the Defense buff
//
//Special Thanks to Koishi for helping me with this hale

#pragma semicolon 1

#include <sourcemod>
#include <sdktools>
#include <sdkhooks>
#include <tf2_stocks>
#include <morecolors>
#include <tf2items>
#include <freak_fortress_2>
#include <freak_fortress_2_subplugin>
#define MB 3
#define ME 2048

#define GRENADE_GL "vo/Demoman_dominationscout05.wav"
#define GRENADE_LNL "vo/Heavy_specialcompleted07.wav"
#define GRENADE_LC "vo/Scout_misc05.wav"
#define GRENADE_FGL "vo/taunts/Spy_taunts16.wav"
#define GRENADE_IB "vo/taunts/Sniper_taunts16.wav"

new customweapons;
new weapondifficulty;
new Bloodriderboss;
new weaponmode;
new bool: newgrenade = false;

public Plugin:myinfo = {
   name = "Freak Fortress 2: Bloodriders Subplugin",
   author = "M7",
   description="Bloodriders abilities",
};

public OnPluginStart2()
{
    HookEvent("arena_round_start", OnRoundStart, EventHookMode_PostNoCopy);
}

public OnMapStart()
{
    PrecacheSound(GRENADE_GL,true);
	PrecacheSound(GRENADE_LNL,true);
	PrecacheSound(GRENADE_LC,true);
	PrecacheSound(GRENADE_FGL,true);
	PrecacheSound(GRENADE_IB,true);
}

public Action:FF2_OnAbility2(index,const String:plugin_name[],const String:ability_name[],action)
{
	if (!strcmp(ability_name,"rage_bloodrider")) 	
	{				
		new Boss=GetClientOfUserId(FF2_GetBossUserId(index));
		TF2_AddCondition(Boss,TFCond_Buffed,FF2_GetAbilityArgumentFloat(index,this_plugin_name,ability_name,1,5.0)); 
		TF2_AddCondition(Boss,TFCond_DefenseBuffed,FF2_GetAbilityArgumentFloat(index,this_plugin_name,ability_name,1,5.0)); 
		TF2_AddCondition(Boss,TFCond_RegenBuffed,FF2_GetAbilityArgumentFloat(index,this_plugin_name,ability_name,1,5.0)); 
		new grenade=FF2_GetAbilityArgument(index,this_plugin_name,ability_name, 2);	//Ammo
		TF2_RemoveAllWeapons(Boss);
		if(weaponmode==1)
		{
		    SetEntPropEnt(Bloodriderboss, Prop_Send, "m_hActiveWeapon", SpawnWeapon(Bloodriderboss, "tf_weapon_grapplinghook", 1152, 101, 5, "5 ; 3 ; 241 ; 0 ; 280 ; 26 ; 547 ; 0 ; 199 ; 0 ; 712 ; 1"));	
		}
		Randomclass(Boss);
		Randomweapon(Boss);
		Grenadelauncherrage(Boss);
		SetAmmo(Boss, TFWeaponSlot_Primary,grenade);
		CreateTimer(FF2_GetAbilityArgumentFloat(index,this_plugin_name,ability_name,3,5.0),OldGrenade,index);
		if(newgrenade==false)
		        newgrenade=true;
    }
	else if (!strcmp(ability_name,"lifelose_bloodrider")) 	
	{	
		new Boss=GetClientOfUserId(FF2_GetBossUserId(index));
		TF2_AddCondition(Boss,TFCond_Kritzkrieged,FF2_GetAbilityArgumentFloat(index,this_plugin_name,ability_name,1,5.0));  //Crits
		TF2_AddCondition(Boss,TFCond_DefenseBuffed,FF2_GetAbilityArgumentFloat(index,this_plugin_name,ability_name,2,5.0));  //Defense
		new grenade=FF2_GetAbilityArgument(index,this_plugin_name,ability_name, 3);	//Ammo
		TF2_RemoveAllWeapons(Boss);
		if(weaponmode==1)
		{
		    SetEntPropEnt(Bloodriderboss, Prop_Send, "m_hActiveWeapon", SpawnWeapon(Bloodriderboss, "tf_weapon_grapplinghook", 1152, 101, 5, "5 ; 3 ; 241 ; 0 ; 280 ; 26 ; 547 ; 0 ; 199 ; 0 ; 712 ; 1"));	
		}
		Randomclass(Boss);
		Randomweapon(Boss);
		Grenadelauncherrage(Boss);
		SetAmmo(Boss, TFWeaponSlot_Primary,grenade);
		CreateTimer(FF2_GetAbilityArgumentFloat(index,this_plugin_name,ability_name,4,5.0),OldGrenade,index);
		if(newgrenade==false)
		        newgrenade=true;
    }
}

public Action:OldGrenade(Handle:hTimer,any:index)
{
    if(newgrenade==true)
	{
	    newgrenade=false;
	    new Boss=GetClientOfUserId(FF2_GetBossUserId(index));
	    Grenadelauncher(Boss);
	}
}

Grenadelauncher(client)
{
	TF2_RemoveWeaponSlot(client, TFWeaponSlot_Secondary); //just incase
	TF2_RemoveWeaponSlot(client, TFWeaponSlot_Primary);
	switch(weapondifficulty)
	{
				case 1: // Easy
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 206, 101, 5, "1 ; 0.01 ; 6 ; 0.6 ; 97 ; 0.5 ; 28 ; 1 ; 2025 ; 3 ; 4 ; 5 ; 176 ; 1 ; 114 ; 1 ; 112 ; 5 ; 2013 ; 2007 ; 2014 ; 1")); 
				case 2:	// Normal
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 206, 101, 5, "1 ; 0.05 ; 6 ; 0.55 ; 97 ; 0.45 ; 28 ; 1 ; 2025 ; 3 ; 4 ; 7 ; 176 ; 1 ; 114 ; 1 ; 112 ; 10 ; 2013 ; 2007 ; 2014 ; 1")); 
				case 3:	// Intermediate
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 206, 101, 5, "1 ; 0.10 ; 6 ; 0.40 ; 97 ; 0.35 ; 28 ; 1 ; 2025 ; 3 ; 4 ; 10 ; 176 ; 1 ; 114 ; 1 ; 112 ; 20 ; 37 ; 1.0 ; 2013 ; 2007 ; 2014 ; 1")); 
				case 4: // Difficult
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 206, 101, 5, "1 ; 0.20 ; 6 ; 0.35 ; 97 ; 0.30 ; 28 ; 1 ; 2025 ; 3 ; 4 ; 20 ; 176 ; 1 ; 114 ; 1 ; 112 ; 50 ; 37 ; 1.5 ; 2013 ; 2007 ; 2014 ; 1")); 
				case 5: // Very Hard
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 206, 101, 5, "1 ; 0.30 ; 6 ; 0.30 ; 97 ; 0.25 ; 28 ; 1 ; 2025 ; 3 ; 4 ; 50 ; 176 ; 1 ; 114 ; 1 ; 112 ; 75 ; 37 ; 1.5 ; 2013 ; 2007 ; 2014 ; 1")); 
				case 6: // Insane
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 206, 101, 5, "1 ; 0.40 ; 6 ; 0.25 ; 97 ; 0.20 ; 28 ; 1 ; 2025 ; 3 ; 4 ; 75 ; 176 ; 1 ; 114 ; 1 ; 112 ; 100 ; 37 ; 2.0 ; 2013 ; 2007 ; 2014 ; 1")); 
				case 7: // Godlike
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 206, 101, 5, "1 ; 0.60 ; 6 ; 0.2 ; 97 ; 0.15 ; 28 ; 1 ; 2025 ; 3 ; 4 ; 90 ; 176 ; 1 ; 114 ; 1 ; 112 ; 200 ; 37 ; 2.5 ; 2013 ; 2007 ; 2014 ; 1")); 
				case 8: // Grenade Hell
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 206, 101, 5, "1 ; 0.80 ; 6 ; 0.15 ; 97 ; 0.10 ; 28 ; 1 ; 2025 ; 3 ; 4 ; 110 ; 176 ; 1 ; 114 ; 1 ; 112 ; 500 ; 37 ; 5.0 ; 2013 ; 2007 ; 2014 ; 1")); 
				case 9: // True Bloodrider
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 206, 101, 5, "6 ; 0.10 ; 97 ; 0.05 ; 28 ; 1 ; 2025 ; 3 ; 4 ; 130 ; 176 ; 1 ; 114 ; 1 ; 112 ; 1000 ; 37 ; 10.0 ; 2013 ; 2007 ; 2014 ; 1")); 
	}
	SetAmmo(client, TFWeaponSlot_Primary,99999999);
}

stock SpawnWeapon(client,String:name[],index,level,qual,String:att[])
{
   new Handle:hWeapon = TF2Items_CreateItem(OVERRIDE_ALL|FORCE_GENERATION);
   TF2Items_SetClassname(hWeapon, name);
   TF2Items_SetItemIndex(hWeapon, index);
   TF2Items_SetLevel(hWeapon, level);
   TF2Items_SetQuality(hWeapon, qual);
   new String:atts[32][32];
   new count = ExplodeString(att, " ; ", atts, 32, 32);
   if (count > 0)
   {
      TF2Items_SetNumAttributes(hWeapon, count/2);
      new i2 = 0;
      for (new i = 0; i < count; i+=2)
      {
         TF2Items_SetAttribute(hWeapon, i2, StringToInt(atts[i]), StringToFloat(atts[i+1]));
         i2++;
      }
   }
   else
      TF2Items_SetNumAttributes(hWeapon, 0);
   if (hWeapon==INVALID_HANDLE)
      return -1;
   new entity = TF2Items_GiveNamedItem(client, hWeapon);
   CloseHandle(hWeapon);
   EquipPlayerWeapon(client, entity);
   return entity;
}

stock SetAmmo(client, slot, ammo)
{
	new weapon = GetPlayerWeaponSlot(client, slot);
	if (IsValidEntity(weapon))
	{
		new iOffset = GetEntProp(weapon, Prop_Send, "m_iPrimaryAmmoType", 1)*4;
		new iAmmoTable = FindSendPropInfo("CTFPlayer", "m_iAmmo");
		SetEntData(client, iAmmoTable+iOffset, ammo, 4, true);
	}
}

Randomclass(client)
{
    if(TF2_GetPlayerClass(client)==TFClass_DemoMan)
	{  
	    SetVariantString("models/freak_fortress_2/bloodrider/bloodrider_v2.mdl");
	    AcceptEntityInput(client, "SetCustomModel");
		SetEntProp(client, Prop_Send, "m_bUseClassAnimations", 1);
	    switch (GetRandomInt(0, 7))
	    {
		    case 0:
			    TF2_SetPlayerClass(client, TFClass_Scout);
			case 1:
			    TF2_SetPlayerClass(client, TFClass_Soldier);
		    case 2:
			    TF2_SetPlayerClass(client, TFClass_Pyro);
		    case 3:
			    TF2_SetPlayerClass(client, TFClass_Heavy);
		    case 4:
			    TF2_SetPlayerClass(client, TFClass_Engineer);
		    case 5:
			    TF2_SetPlayerClass(client, TFClass_Medic);
		    case 6:
			    TF2_SetPlayerClass(client, TFClass_Sniper);
		    case 7:
			    TF2_SetPlayerClass(client, TFClass_Spy);
	    }
	}
	
	else if(TF2_GetPlayerClass(client)==TFClass_Scout)
	{
	    SetVariantString("models/freak_fortress_2/bloodrider/bloodrider_v2.mdl");
		AcceptEntityInput(client, "SetCustomModel");
		SetEntProp(client, Prop_Send, "m_bUseClassAnimations", 1);
	    switch (GetRandomInt(0, 7))
	    {
		    case 0:
			    TF2_SetPlayerClass(client, TFClass_DemoMan);
		    case 1:
			    TF2_SetPlayerClass(client, TFClass_Soldier);
		    case 2:
			    TF2_SetPlayerClass(client, TFClass_Pyro);
		    case 3:
			    TF2_SetPlayerClass(client, TFClass_Heavy);
		    case 4:
			    TF2_SetPlayerClass(client, TFClass_Engineer);
		    case 5:
			    TF2_SetPlayerClass(client, TFClass_Medic);
		    case 6:
			    TF2_SetPlayerClass(client, TFClass_Sniper);
		    case 7:
			    TF2_SetPlayerClass(client, TFClass_Spy);
	    }
	}
	
	else if(TF2_GetPlayerClass(client)==TFClass_Soldier)
	{
	    SetVariantString("models/freak_fortress_2/bloodrider/bloodrider_v2.mdl");
		AcceptEntityInput(client, "SetCustomModel");
		SetEntProp(client, Prop_Send, "m_bUseClassAnimations", 1);
	    switch (GetRandomInt(0, 7))
	    {
		    case 0:
			    TF2_SetPlayerClass(client, TFClass_Scout);
		    case 1:
			    TF2_SetPlayerClass(client, TFClass_DemoMan);
		    case 2:
			    TF2_SetPlayerClass(client, TFClass_Pyro);
		    case 3:
			    TF2_SetPlayerClass(client, TFClass_Heavy);
		    case 4:
			    TF2_SetPlayerClass(client, TFClass_Engineer);
		    case 5:
			    TF2_SetPlayerClass(client, TFClass_Medic);
		    case 6:
			    TF2_SetPlayerClass(client, TFClass_Sniper);
		    case 7:
			    TF2_SetPlayerClass(client, TFClass_Spy);
	    }
	}
	
	else if(TF2_GetPlayerClass(client)==TFClass_Pyro)
	{
	    SetVariantString("models/freak_fortress_2/bloodrider/bloodrider_v2.mdl");
		AcceptEntityInput(client, "SetCustomModel");
		SetEntProp(client, Prop_Send, "m_bUseClassAnimations", 1);
	    switch (GetRandomInt(0, 7))
	    {
		    case 0:
			    TF2_SetPlayerClass(client, TFClass_Scout);
		    case 1:
			    TF2_SetPlayerClass(client, TFClass_Soldier);
		    case 2:
			    TF2_SetPlayerClass(client, TFClass_DemoMan);
		    case 3:
			    TF2_SetPlayerClass(client, TFClass_Heavy);
		    case 4:
			    TF2_SetPlayerClass(client, TFClass_Engineer);
		    case 5:
			    TF2_SetPlayerClass(client, TFClass_Medic);
		    case 6:
			    TF2_SetPlayerClass(client, TFClass_Sniper);
		    case 7:
			    TF2_SetPlayerClass(client, TFClass_Spy);
	    }
	}
	
	else if(TF2_GetPlayerClass(client)==TFClass_Heavy)
	{
	    SetVariantString("models/freak_fortress_2/bloodrider/bloodrider_v2.mdl");
	    AcceptEntityInput(client, "SetCustomModel");
		SetEntProp(client, Prop_Send, "m_bUseClassAnimations", 1);
	    switch (GetRandomInt(0, 7))
	    {
		    case 0:
			    TF2_SetPlayerClass(client, TFClass_Scout);
		    case 1:
			    TF2_SetPlayerClass(client, TFClass_Soldier);
		    case 2:
			    TF2_SetPlayerClass(client, TFClass_Pyro);
		    case 3:
			    TF2_SetPlayerClass(client, TFClass_DemoMan);
		    case 4:
			    TF2_SetPlayerClass(client, TFClass_Engineer);
		    case 5:
			    TF2_SetPlayerClass(client, TFClass_Medic);
		    case 6:
			    TF2_SetPlayerClass(client, TFClass_Sniper);
		    case 7:
			    TF2_SetPlayerClass(client, TFClass_Spy);
	    }
	}
	
	else if(TF2_GetPlayerClass(client)==TFClass_Engineer)
	{
	    SetVariantString("models/freak_fortress_2/bloodrider/bloodrider_v2.mdl");
		AcceptEntityInput(client, "SetCustomModel");
		SetEntProp(client, Prop_Send, "m_bUseClassAnimations", 1);
	    switch (GetRandomInt(0, 7))
	    {
		    case 0:
			    TF2_SetPlayerClass(client, TFClass_Scout);
		    case 1:
			    TF2_SetPlayerClass(client, TFClass_Soldier);
		    case 2:
			    TF2_SetPlayerClass(client, TFClass_Pyro);
		    case 3:
			    TF2_SetPlayerClass(client, TFClass_Heavy);
		    case 4:
			    TF2_SetPlayerClass(client, TFClass_DemoMan);
		    case 5:
			    TF2_SetPlayerClass(client, TFClass_Medic);
		    case 6:
			    TF2_SetPlayerClass(client, TFClass_Sniper);
		    case 7:
			    TF2_SetPlayerClass(client, TFClass_Spy);
	    }
	}
	
	else if(TF2_GetPlayerClass(client)==TFClass_Medic)
	{
	    SetVariantString("models/freak_fortress_2/bloodrider/bloodrider_v2.mdl");
		AcceptEntityInput(client, "SetCustomModel");
		SetEntProp(client, Prop_Send, "m_bUseClassAnimations", 1);
	    switch (GetRandomInt(0, 7))
	    {
		    case 0:
			TF2_SetPlayerClass(client, TFClass_Scout);
		    case 1:
			TF2_SetPlayerClass(client, TFClass_Soldier);
		    case 2:
			TF2_SetPlayerClass(client, TFClass_Pyro);
		    case 3:
			TF2_SetPlayerClass(client, TFClass_Heavy);
		    case 4:
			TF2_SetPlayerClass(client, TFClass_Engineer);
		    case 5:
			TF2_SetPlayerClass(client, TFClass_DemoMan);
		    case 6:
			TF2_SetPlayerClass(client, TFClass_Sniper);
		    case 7:
			TF2_SetPlayerClass(client, TFClass_Spy);
	    }
	}
	
	else if(TF2_GetPlayerClass(client)==TFClass_Sniper)
	{
	    SetVariantString("models/freak_fortress_2/bloodrider/bloodrider_v2.mdl");
		AcceptEntityInput(client, "SetCustomModel");
	    SetEntProp(client, Prop_Send, "m_bUseClassAnimations", 1);
	    switch (GetRandomInt(0, 7))
	    {
		    case 0:
			TF2_SetPlayerClass(client, TFClass_Scout);
		    case 1:
			TF2_SetPlayerClass(client, TFClass_Soldier);
		    case 2:
			TF2_SetPlayerClass(client, TFClass_Pyro);
		    case 3:
			TF2_SetPlayerClass(client, TFClass_Heavy);
		    case 4:
		    TF2_SetPlayerClass(client, TFClass_Engineer);
		    case 5:
			TF2_SetPlayerClass(client, TFClass_Medic);
		    case 6:
			TF2_SetPlayerClass(client, TFClass_DemoMan);
		    case 7:
			TF2_SetPlayerClass(client, TFClass_Spy);
	    }
	}
	
	else if(TF2_GetPlayerClass(client)==TFClass_Spy)
	{
	    SetVariantString("models/freak_fortress_2/bloodrider/bloodrider_v2.mdl");
		AcceptEntityInput(client, "SetCustomModel");
		SetEntProp(client, Prop_Send, "m_bUseClassAnimations", 1);
	    switch (GetRandomInt(0, 7))
	    {
		    case 0:
			TF2_SetPlayerClass(client, TFClass_Scout);
		    case 1:
			TF2_SetPlayerClass(client, TFClass_Soldier);
		    case 2:
			TF2_SetPlayerClass(client, TFClass_Pyro);
		    case 3:
			TF2_SetPlayerClass(client, TFClass_Heavy);
		    case 4:
			TF2_SetPlayerClass(client, TFClass_Engineer);
		    case 5:
			TF2_SetPlayerClass(client, TFClass_Medic);
		    case 6:
		    TF2_SetPlayerClass(client, TFClass_Sniper);
		    case 7:
		    TF2_SetPlayerClass(client, TFClass_DemoMan);
	    }
	}
}

Randomweapon(client)
{
    if(TF2_GetPlayerClass(client)==TFClass_DemoMan)
	{  
	  SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_bottle", 191, 100, 5, "2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1 ; 68 ; 2 ; 2 ; 3"));
	}
	else if(TF2_GetPlayerClass(client)==TFClass_Scout)
	{  
	  SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_bat", 190, 100, 5, "2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1 ; 68 ; 1 ; 2 ; 1.5"));
	}
	else if(TF2_GetPlayerClass(client)==TFClass_Soldier)
	{  
	  SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_shovel", 196, 100, 5, "2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1 ; 68 ; 2 ; 2 ; 3"));
	}
	else if(TF2_GetPlayerClass(client)==TFClass_Pyro)
	{  
	  SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_fireaxe", 192, 100, 5, "2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1 ; 68 ; 2 ; 2 ; 3"));
	}
	else if(TF2_GetPlayerClass(client)==TFClass_Heavy)
	{  
	  SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_fists", 195, 100, 5, "2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1 ; 68 ; 2 ; 2 ; 3"));
	}
	else if(TF2_GetPlayerClass(client)==TFClass_Engineer)
	{  
	  SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_wrench", 197, 100, 5, "2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1 ; 68 ; 2 ; 2 ; 3"));
	}
	else if(TF2_GetPlayerClass(client)==TFClass_Medic)
	{  
	  SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_bonesaw", 198, 100, 5, "2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1 ; 68 ; 2 ; 2 ; 3"));
	}
	else if(TF2_GetPlayerClass(client)==TFClass_Sniper)
	{  
	  SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_club", 193, 100, 5, "2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1 ; 68 ; 2 ; 2 ; 3"));
	}
	else if(TF2_GetPlayerClass(client)==TFClass_Spy)
	{  
	  SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_knife", 194, 100, 5, "2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1 ; 68 ; 2 ; 2 ; 1.5"));
	}
}

Grenadelauncherrage(client)
{
    switch (GetRandomInt(0,4))
	{
		case 0: // Grenade launcher
		{
			switch(weapondifficulty)
			{
				case 1: // Easy
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 206, 101, 5, "128 ; 1 ; 4 ; 10 ; 1 ; 0.01 ; 6 ; 0.4 ; 411 ; 150.0 ; 97 ; 0.6 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1 ; 112 ; 10 ; 37 ; 1.0"));
				case 2:	// Normal
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 206, 101, 5, "128 ; 1 ; 4 ; 30 ; 1 ; 0.05 ; 6 ; 0.35 ; 411 ; 150.0 ; 181 ; 1.0 ; 97 ; 0.5 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1 ; 112 ; 20 ; 37 ; 1.0"));
				case 3:	// Intermediate
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 206, 101, 5, "128 ; 1 ; 4 ; 50 ; 1 ; 0.10 ; 6 ; 0.3 ; 411 ; 150.0 ; 181 ; 1.0 ; 97 ; 0.45 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1 ; 112 ; 30 ; 37 ; 1.0"));
				case 4: // Difficult
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 206, 101, 5, "128 ; 1 ; 4 ; 70 ; 1 ; 0.20 ; 6 ; 0.25 ; 411 ; 150.0 ; 181 ; 1.5 ; 97 ; 0.35 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1 ; 112 ; 50 ; 37 ; 1.0"));
				case 5: // Very Hard
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 206, 101, 5, "128 ; 1 ; 4 ; 90 ; 1 ; 0.30 ; 6 ; 0.20 ; 411 ; 150.0 ; 181 ; 2.0 ; 97 ; 0.30 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1 ; 112 ; 75 ; 37 ; 2.0"));
				case 6: // Insane
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 206, 101, 5, "128 ; 1 ; 4 ; 110 ; 1 ; 0.50 ; 6 ; 0.15 ; 411 ; 150.0 ; 181 ; 2.0 ; 97 ; 0.25 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1 ; 112 ; 100 ; 37 ; 2.0"));
				case 7: // Godlike
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 206, 101, 5, "128 ; 1 ; 4 ; 145 ; 1 ; 0.75 ; 6 ; 0.10 ; 411 ; 150.0 ; 181 ; 2.0 ; 97 ; 0.2 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1 ; 112 ; 125 ; 37 ; 3.0"));
				case 8: // Grenade Hell
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 206, 101, 5, "128 ; 1 ; 4 ; 165 ; 1 ; 0.90 ; 6 ; 0.05 ; 411 ; 150.0 ; 181 ; 5.0 ; 97 ; 0.10 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1 ; 112 ; 150 ; 37 ; 4.0"));
				case 9: // True Bloodrider
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 206, 101, 5, "128 ; 1 ; 4 ; 200 ; 6 ; 0.03 ; 411 ; 150.0 ; 181 ; 10.0 ; 97 ; 0.05 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1 ; 112 ; 500 ; 37 ; 10.0"));
			}
			EmitSoundToAll(GRENADE_GL);
		}
		case 1: // Loch n Load
		{
			switch(weapondifficulty)
			{
				case 1: // Easy
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 308, 101, 5, "128 ; 1 ; 1 ; 0.01 ; 6 ; 0.4 ; 97 ; 0.5 ; 28 ; 1 ; 4 ; 10 ; 176 ; 1 ; 114 ; 1 ; 112 ; 10 ; 37 ; 1.0 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1"));
				case 2:	// Normal
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 308, 101, 5, "128 ; 1 ; 1 ; 0.05 ; 6 ; 0.35 ; 97 ; 0.45 ; 28 ; 1 ; 4 ; 20 ; 176 ; 1 ; 114 ; 1 ; 112 ; 20 ; 37 ; 1.0 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1"));
				case 3:	// Intermediate
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 308, 101, 5, "128 ; 1 ; 1 ; 0.1 ; 6 ; 0.30 ; 97 ; 0.40 ; 28 ; 1 ; 4 ; 45 ; 176 ; 1 ; 114 ; 1 ; 112 ; 45 ; 37 ; 1.0 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1"));
				case 4: // Difficult
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 308, 101, 5, "128 ; 1 ; 1 ; 0.2 ; 6 ; 0.25 ; 97 ; 0.35 ; 28 ; 1 ; 4 ; 60 ; 176 ; 1 ; 114 ; 1 ; 112 ; 60 ; 37 ; 1.5 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1"));
				case 5: // Very Hard
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 308, 101, 5, "128 ; 1 ; 1 ; 0.35 ; 6 ; 0.20 ; 97 ; 0.25 ; 28 ; 1 ; 4 ; 80 ; 176 ; 1 ; 114 ; 1 ; 112 ; 80 ; 37 ; 1.5 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1"));
				case 6: // Insane
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 308, 101, 5, "128 ; 1 ; 1 ; 0.55 ; 6 ; 0.15 ; 97 ; 0.15 ; 28 ; 1 ; 4 ; 100 ; 176 ; 1 ; 114 ; 1 ; 112 ; 100 ; 37 ; 2.0 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1"));
				case 7: // Godlike
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 308, 101, 5, "128 ; 1 ; 1 ; 0.75 ; 6 ; 0.1 ; 97 ; 0.1 ; 28 ; 1 ; 4 ; 200 ; 176 ; 1 ; 114 ; 1 ; 112 ; 200 ; 37 ; 3.0 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1"));
				case 8: // Grenade Hell
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 308, 101, 5, "128 ; 1 ; 1 ; 0.90 ; 6 ; 0.05 ; 97 ; 0.05 ; 28 ; 1 ; 4 ; 500 ; 176 ; 1 ; 114 ; 1 ; 112 ; 500 ; 37 ; 5.0 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1"));
				case 9: // True Bloodrider
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 308, 101, 5, "128 ; 1 ; 6 ; 0.01 ; 97 ; 0.01 ; 28 ; 1 ; 4 ; 1000 ; 176 ; 1 ; 114 ; 1 ; 112 ; 1000 ; 37 ; 10.0 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1"));
			}
			EmitSoundToAll(GRENADE_LNL);
		}
		case 2: // Loose Cannon
		{
			switch(weapondifficulty)
			{
				case 1: // Easy
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_cannon", 996, 101, 5, "128 ; 1 ; 1 ; 0.4 ; 99 ; 1.1 ; 3 ; 0.25 ; 104 ; 0.01 ; 96 ; 100 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1"));
				case 2:	// Normal
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_cannon", 996, 101, 5, "128 ; 1 ; 1 ; 0.5 ; 99 ; 1.3 ; 3 ; 0.25 ; 104 ; 0.03 ; 96 ; 80 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1"));
				case 3:	// Intermediate
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_cannon", 996, 101, 5, "128 ; 1 ; 1 ; 0.75 ; 99 ; 1.6 ; 3 ; 0.25 ; 104 ; 0.08 ; 37 ; 1.0 ; 96 ; 70 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1"));
				case 4: // Difficult
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_cannon", 996, 101, 5, "128 ; 1 ; 1 ; 0.9 ; 99 ; 1.9 ; 3 ; 0.25 ; 104 ; 0.11 ; 37 ; 1.5 ; 208 ; 1 ; 96 ; 40 ; 74 ; 0.25 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1"));
				case 5: // Very Hard
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_cannon", 996, 101, 5, "128 ; 1 ; 2 ; 1.1 ; 99 ; 2.3 ; 3 ; 0.25 ; 104 ; 0.15 ; 37 ; 2.0 ; 208 ; 1 ; 96 ; 20 ; 74 ; 0.4 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1"));
				case 6: // Insane
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_cannon", 996, 101, 5, "128 ; 1 ; 2 ; 1.4 ; 99 ; 2.7 ; 3 ; 0.25 ; 104 ; 0.3 ; 37 ; 3.0 ; 208 ; 1 ; 96 ; 10 ; 74 ; 0.7 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1"));
				case 7: // Godlike
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_cannon", 996, 101, 5, "128 ; 1 ; 2 ; 1.7 ; 99 ; 3.3 ; 3 ; 0.25 ; 104 ; 0.45 ; 37 ; 4.5 ; 208 ; 1 ; 96 ; 5 ; 74 ; 1.0 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1"));
				case 8: // Grenade Hell
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_cannon", 996, 101, 5, "128 ; 1 ; 2 ; 2.4 ; 99 ; 3.7 ; 3 ; 0.25 ; 104 ; 0.60 ; 37 ; 7.0 ; 208 ; 1 ; 96 ; 2.5 ; 74 ; 2.0 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1"));
				case 9: // True Bloodrider
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_cannon", 996, 101, 5, "128 ; 1 ; 2 ; 3.1 ; 99 ; 4.0 ; 3 ; 0.25 ; 104 ; 0.80 ; 37 ; 10.0 ; 208 ; 1 ; 96 ; 0.5 ; 74 ; 5.0 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1"));
			}
			EmitSoundToAll(GRENADE_LC);
		}
		case 3: // Festive Grenade Launcher
		{
			switch(weapondifficulty)
			{
				case 1: // Easy
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 1007, 101, 5, "128 ; 1 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1 ; 1 ; 0.10"));
				case 2: // Normal
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 1007, 101, 5, "128 ; 1 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1 ; 1 ; 0.20"));
				case 3: // Intermediate
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 1007, 101, 5, "128 ; 1 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1 ; 1 ; 0.30"));
				case 4: // Difficult
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 1007, 101, 5, "128 ; 1 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1 ; 1 ; 0.40"));
				case 5: // Very Hard
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 1007, 101, 5, "128 ; 1 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1 ; 1 ; 0.50"));
				case 6: // Insane
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 1007, 101, 5, "128 ; 1 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1 ; 1 ; 0.60"));
				case 7: // Godlike
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 1007, 101, 5, "128 ; 1 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1 ; 1 ; 0.75"));
				case 8: // Grenade Hell
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 1007, 101, 5, "128 ; 1 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1 ; 1 ; 0.90"));
				case 9: // True Bloodrider
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 1007, 101, 5, "128 ; 1 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1"));
			}
			EmitSoundToAll(GRENADE_FGL);
		}
		case 4: // Iron Bomber
		{
			switch(weapondifficulty)
			{
				case 1: // Easy
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 1151, 101, 5, "128 ; 1 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1 ; 1 ; 0.1 ; 15 ; 1 ; 21 ; 0.1 ; 22 ; 1 ; 32 ; 1 ; 37 ; 1.0 ; 149 ; 1"));
				case 2: // Normal
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 1151, 101, 5, "128 ; 1 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1 ; 1 ; 0.25 ; 15 ; 1 ; 21 ; 0.25 ; 22 ; 1 ; 32 ; 2 ; 37 ; 1.5 ; 149 ; 1.5"));
				case 3: // Intermediate
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 1151, 101, 5, "128 ; 1 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1 ; 1 ; 0.40 ; 15 ; 1 ; 21 ; 0.40 ; 22 ; 1 ; 32 ; 3 ; 37 ; 1.5 ; 149 ; 2.0"));
				case 4: // Difficult
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 1151, 101, 5, "128 ; 1 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1 ; 1 ; 0.50 ; 15 ; 1 ; 21 ; 0.55 ; 22 ; 1 ; 32 ; 3 ; 37 ; 2.5 ; 149 ; 2.5 ; 208 ; 1"));
				case 5: // Very Hard
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 1151, 101, 5, "128 ; 1 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1 ; 1 ; 0.65 ; 15 ; 1 ; 21 ; 0.75 ; 22 ; 1 ; 32 ; 5 ; 37 ; 3.5 ; 149 ; 3.5 ; 208 ; 1"));
				case 6: // Insane
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 1151, 101, 5, "128 ; 1 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1 ; 1 ; 0.75 ; 15 ; 1 ; 21 ; 0.80 ; 22 ; 1 ; 32 ; 6 ; 37 ; 4.5 ; 149 ; 4.5 ; 208 ; 1 ; 209 ; 1"));
				case 7: // Godlike
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 1151, 101, 5, "128 ; 1 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1 ; 1 ; 0.80 ; 15 ; 1 ; 21 ; 0.85 ; 22 ; 1 ; 32 ; 8 ; 37 ; 6.5 ; 149 ; 6.5 ; 208 ; 1 ; 209 ; 1"));
				case 8: // Grenade Hell
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 1151, 101, 5, "128 ; 1 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1 ; 1 ; 0.90 ; 15 ; 1 ; 21 ; 0.95 ; 22 ; 1 ; 32 ; 10 ; 37 ; 8.5 ; 149 ; 7.5 ; 208 ; 1 ; 24 ; 1 ; 20 ; 1"));
				case 9: // True Bloodrider
					SetEntPropEnt(client, Prop_Send, "m_hActiveWeapon", SpawnWeapon(client, "tf_weapon_grenadelauncher", 1151, 101, 5, "128 ; 1 ; 2025 ; 3 ; 2013 ; 2007 ; 2014 ; 1 ; 15 ; 1 ; 22 ; 1 ; 32 ; 20 ; 37 ; 12.5 ; 149 ; 10 ; 208 ; 1 ; 24 ; 1 ; 20 ; 1 ; 437 ; 1 ; 438 ; 1 ; 31 ; 10"));
			}
			EmitSoundToAll(GRENADE_IB);
		}
	}
}

public Action:OnRoundStart(Handle:event, const String:name[], bool:dontBroadcast)
{
	    Bloodriderboss = GetClientOfUserId(FF2_GetBossUserId(0));
		if (Bloodriderboss>0)
		{
			if (FF2_HasAbility(0, this_plugin_name, "Bloodrider_config"))
			{	
				weapondifficulty=FF2_GetAbilityArgument(0,this_plugin_name,"Bloodrider_config", 1, 2);
				customweapons=FF2_GetAbilityArgument(0,this_plugin_name,"Bloodrider_config", 2); // use custom weapons
				weaponmode=FF2_GetAbilityArgument(0,this_plugin_name,"Bloodrider_config", 3);
				switch(weapondifficulty)
				{
					case 0:
					{
						switch (GetRandomInt(0,8))
						{
						case 0:
							weapondifficulty=1, CPrintToChatAll("Bloodrider's Level: Easy");
						case 1:
							weapondifficulty=2, CPrintToChatAll("Bloodrider's Level: Normal");
						case 2:
							weapondifficulty=3, CPrintToChatAll("Bloodrider's Level: Intermediate");
						case 3:
							weapondifficulty=4, CPrintToChatAll("Bloodrider's Level: Difficult");
						case 4:
							weapondifficulty=5, CPrintToChatAll("Bloodrider's Level: Very Hard");
						case 5:
							weapondifficulty=6, CPrintToChatAll("Bloodrider's Level: Extreme");
						case 6:
							weapondifficulty=7, CPrintToChatAll("Bloodrider's Level: Godlike");
						case 7:
							weapondifficulty=8, CPrintToChatAll("Bloodrider's Level: Grenade Hell");
						case 8:
							weapondifficulty=9, CPrintToChatAll("Bloodrider's Level: True Bloodrider");
						}
					}
					case 1:
						CPrintToChatAll("Bloodrider's Level: Easy");
					case 2:
						CPrintToChatAll("Bloodrider's Level: Normal");
					case 3:
						CPrintToChatAll("Bloodrider's Level: Intermediate");
					case 4:
						CPrintToChatAll("Bloodrider's Level: Difficult");
					case 5:
						CPrintToChatAll("Bloodrider's Level: Very Hard");
					case 6:
						CPrintToChatAll("Bloodrider's Level: Extreme");
					case 7:
						CPrintToChatAll("Bloodrider's Level: Godlike");
					case 8:
						CPrintToChatAll("Bloodrider's Level: Grenade Hell");
					case 9:
						CPrintToChatAll("Bloodrider's Level: True Bloodrider");
				}
				switch(weaponmode)
				{
				    case 0:
				    {
				        TF2_RemoveAllWeapons(Bloodriderboss);
                        Grenadelauncher(Bloodriderboss);
						SetAmmo(Bloodriderboss, TFWeaponSlot_Primary,999999);
                    }
				    case 1:
				    {
				        TF2_RemoveAllWeapons(Bloodriderboss);
						SetEntPropEnt(Bloodriderboss, Prop_Send, "m_hActiveWeapon", SpawnWeapon(Bloodriderboss, "tf_weapon_grapplinghook", 1152, 101, 5, "5 ; 3 ; 241 ; 0 ; 280 ; 26 ; 547 ; 0 ; 199 ; 0 ; 712 ; 1"));	
                        Grenadelauncher(Bloodriderboss);
						SetAmmo(Bloodriderboss, TFWeaponSlot_Primary,999999);
                    }
                }					
				if(customweapons!=0)
				{
					decl i;
					for( i = 1; i <= MaxClients; i++ )
					{
						if(IsClientInGame(i) && IsPlayerAlive(i) && GetClientTeam(i)!=FF2_GetBossTeam())
						{
							if(TF2_GetPlayerClass(i)==TFClass_Heavy)
							{
								TF2_RemoveWeaponSlot(i, TFWeaponSlot_Melee);
								SpawnWeapon(i, "tf_weapon_fists", 331, 5, 10, "128 ; 1 ; 6 ; 0.75 ; 206 ; 5.0 ; 205 ; 0.4");
								//128: While weapon is active
								// 6: 25% Faster firing speed
								//206: 5 times more damage taken from Melees
								//205: 60% Reduced damage from ranged weapon (grenade launcher)
								PrintHintText(i, "Your Melee weapon makes you though against the grenade launcher, but weak against the melee Weapons");
							}
							if(TF2_GetPlayerClass(i)==TFClass_DemoMan)
							{
								TF2_RemoveWeaponSlot(i, TFWeaponSlot_Primary);
								SpawnWeapon(i, "tf_weapon_grenadelauncher", 206, 5, 10, "1 ; 0.5 ; 6 ; 0.2 ; 97 ; 0.2 ; 28 ; 1 ; 4 ; 20 ; 37 ; 2.0 ; 354 ; 1.0");
								//1: -50% Damage Penaltry
								//6: 80% Faster firing speed
								//97: 80% Faster reloading speed
								//28: No random critical hits
								//4: 200% More clip size
								//37: Primary Ammo Increased
								//354: Stuns Bloodrider (when he has the grenadelauncher) for 1 sec.)
								PrintHintText(i, "Be Bloodrider!, you can stun bloodrider for 1 seconds!");
							}
						}
					}
				}			
			}
		newgrenade=false;
		}
}